import Pulsar from "pulsar-client";
function newClient() {
    return new Pulsar.Client({
        serviceUrl: "pulsar://localhost:6650",
    });
}
async function producer1() {
    const client = newClient();
    const producer = await client.createProducer({
        topic: "my-topic",
    });
    producer.send({
        data: Buffer.from("testing"),
    });
    await producer.flush();
    await producer.close();
    await client.close();
}
async function consumer1() {
    const client = newClient();
    const consumer = await client.subscribe({
        topic: "my-topic",
        subscription: "my-subscription",
    });
    (async () => {
        for (let i = 0; i < 2; i++) {
            const msg = await consumer.receive();
            const result = msg.getData().toString();
            console.info("consumer1 received", result);
            consumer.acknowledge(msg);
        }
        await consumer.close();
        await client.close();
    })();
}
let continueReading;
async function consumer2() {
    const client = newClient();
    const consumer = await client.subscribe({
        topic: "my-topic",
        subscription: "my-subscription2",
    });
    (async () => {
        const msg = await consumer.receive();
        const result = msg.getData().toString();
        console.info("consumer2 received", result);
        consumer.acknowledge(msg);
        // let's suppose we get disconnected here...
        continueReading = async () => {
            const msg = await consumer.receive();
            const result = msg.getData().toString();
            console.info("consumer2 received", result);
            consumer.acknowledge(msg);
            await consumer.close();
            await client.close();
        };
    })();
}
await consumer1();
await consumer2();
await producer1();
// ...
await producer1();
await continueReading();
